.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

TestRegs =	1	; test which registers are preserved
UseLen =	0

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

      szCatStr2 PROTO :DWORD, :DWORD
      szCatStr3 PROTO :DWORD, :DWORD

    ; ********************************
    ; BASIC string function emulation
    ; ********************************
      addx$ MACRO lpSource,lpAppend
        invoke szCatStr2,tstarg(lpSource),reparg(lpAppend)
        EXITM <eax>
      ENDM

add2$ MACRO lpDest,args:VARARG
LOCAL flag
  FOR argX, <args>
	ifndef flag
		flag = 1
		invoke szCatStr3, tstarg(lpDest),reparg(argX)
	else
		invoke szCatStr3, 0, reparg(argX)
	endif
  ENDM
  EXITM <eax>
ENDM

    .data?
      value dd ?

    .data
      buffer db "text ",0,"                                                                                     "
      txt1 db "text 1 ",0
      txt2 db "text 2",0
      txt3 db "text 3",0
      txt4 db "text 4",0
      txt5 db "text 5",0
      txt6 db "text 6",0

      tstbuf db "test ",0,"                                                                                    "
      tst1 db "test 1 ",13,10,0
      tst2 db "test 2 ",13,10,0
      tst3 db "test 3 ",13,10,0
      tst4 db "test 4 ",13,10,0
      tst5 db "test 5 ",13,10,0
      tst6 db "test 6 ",13,10,0

    .code

start:
   
; 

    call main
    print chr$(13, 10, 10)
    inkey
    exit

; 
csize macro algo
LOCAL  tmp$
  tmp$ CATSTR <algo>, <            >	;; 12 blanks
  tmp$ SUBSTR tmp$, 1, 12
  tmp$ CATSTR <print ">, tmp$, < = ">
  tmp$
  mov eax, offset &algo&_END-&algo&
  print str$(eax), 13, 10
ENDM

main proc

    print str$(OFFSET buffer)," original address",13,10,13,10

    invoke szCatStr2,ADDR buffer,ADDR txt1
    print str$(eax)," 1st return address",13,10
    print ADDR buffer,13,10

    invoke szCatStr2,ADDR buffer,ADDR txt2
    print str$(eax)," 2nd return address",13,10
    print ADDR buffer,13, 10, 10, 10

    mov byte ptr tstbuf, 0
    print "test the first macro",13,10
    print chr$("print addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)", 13, 10)
    print addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)

    mov byte ptr tstbuf, 0
    print chr$(13, 10, "test the second macro, old syntax",13,10)
    print chr$("print add2$(add2$(add2$(add2$(add2$(add2$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)", 13, 10)
    print add2$(add2$(add2$(add2$(add2$(add2$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)

    mov byte ptr tstbuf, 0
    print chr$(13, 10, "test the second macro, new syntax",13,10)
    print chr$("print add2$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)", 13, 10)
    print add2$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)
    if TestRegs
	print chr$(13, 10, "Regs preserved:")
	print chr$(13, 10, "addx$/szCatStr2: ")
	push 12345h
	pop ecx
	mov edx, ecx
	mov byte ptr tstbuf, 0
	mov eax, addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	.if ecx==12345h
		pushad
		print "ecx "
		popad
	.endif
	.if edx==12345h
		pushad
		print "edx"
		popad
	.endif
	print chr$(13, 10, "add2$/szCatStr3: ")
	push 12345h
	pop ecx
	mov edx, ecx
	mov byte ptr tstbuf, 0
	mov eax, add2$(add2$(add2$(add2$(add2$(add2$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	.if ecx==12345h
		pushad
		print "ecx "
		popad
	.endif
	.if edx==12345h
		pushad
		print "edx"
		popad
	.endif
    endif

	LOOP_COUNT = 1000000
	print chr$(13, 10, 10, "timings:", 13, 10)

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; version A, syntax 1
		mov byte ptr tstbuf, 0
		mov eax, addx$(addx$(addx$(addx$(addx$(addx$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	counter_end
	print str$(eax), " cycles for addx$", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; version B, syntax 1
		mov byte ptr tstbuf, 0
		mov eax, add2$(add2$(add2$(add2$(add2$(add2$(ADDR tstbuf,ADDR tst1),ADDR tst2),ADDR tst3),ADDR tst4),ADDR tst5),ADDR tst6)
	counter_end
	print str$(eax), " cycles for add2$, old syntax", 13, 10

	invoke Sleep, 200
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; version B, syntax 2
		mov byte ptr tstbuf, 0
		mov eax, add2$(ADDR tstbuf,ADDR tst1,ADDR tst2,ADDR tst3,ADDR tst4,ADDR tst5,ADDR tst6)
	counter_end

	print str$(eax), " cycles for add2$, short syntax", 13, 10, 10, "Code sizes:", 13, 10
	csize szCatStr2
	csize szCatStr3
    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16
szCatStr2 proc lpszSource:DWORD, lpszAdd:DWORD
    invoke szLen,[esp+4]            ; get source length
    mov edx, [esp+4]                ; load source address
    mov ecx, [esp+8]                ; load append string address
    add edx, eax                    ; set write starting position

    push edi
    or edi, -1

  @@:
    add edi, 1
    movzx eax, BYTE PTR [ecx+edi]   ; read byte from append string and zero extend it
    mov [edx+edi], al               ; write append string to end of source
    add eax, eax
    jnz @B

    pop edi

    mov eax, [esp+4]                ; return start address of source for macro

    ret 8

szCatStr2 endp
szCatStr2_END:

align 16
szCatStr3 proc lpszDest:DWORD, lpszAdd:DWORD
.data
  szCatEnd	dd ?
  szCatStart	dd ?
.code
	push edi
	push esi
	mov edi, [esp+8+4]			; load destination address
	.if sdword ptr edi>0
		mov szCatStart, edi		; pointer to be returned in eax
		if UseLen
			add edi, len(edi)		; trashes ecx, edx??
		else

@@:		REPEAT 4
		  movzx eax, byte ptr [edi]
		  test eax, eax
		  je @F
		  inc edi
		ENDM
		jmp @B
@@:
		; dec edi
		endif
	.else
		mov edi, szCatEnd
	.endif
	mov esi, [esp+8+8]			; load append string address

@@:	movzx eax, byte ptr [esi]		; read byte from append string and zero extend it
	mov [edi], al					; write append string to end of source
	inc esi
	inc edi
	test eax, eax
	jne @B

	dec edi
	mov szCatEnd, edi
	mov eax, szCatStart			; return start address of source for macro
	pop esi
	pop edi
	ret 2*4
szCatStr3 endp
szCatStr3_END:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start
OPT_WAIT	0
OPT_Tmp2Asm	1
